//+------------------------------------------------------------------+
//|                                             RangeBars_fromM1.mq4 |
//|                                      Copyright  2009, komposter |
//|                                       mailto:komposter@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, komposter"
#property link      "mailto:komposter@gmail.com"

#include <WinUser32.mqh>

//----     
extern int		PointsInBar	= 100;

int HistoryHandle = -1, HistoryFilePos = 0, hwnd = 0, TicksFilePos = 0, now_time;
double now_close, now_open, now_low, now_high, now_volume;
string _Symbol;

int _Period, _PeriodSec, pre_time, last_fpos = 0;
double pre_close;

int init()
{
	int    _GetLastError = 0, cnt_ticks = 0, cnt_bars = 0, temp[13];

	//   ,    off-line 
	_Symbol = Symbol();
   hwnd = 0;

	//  ,     
	string file_name = StringConcatenate( "RB_", _Symbol, PointsInBar, ".hst" );
	HistoryHandle = FileOpenHistory( file_name, FILE_BIN | FILE_WRITE );
	if ( HistoryHandle < 0 )
	{
		_GetLastError = GetLastError();
		Alert( "FileOpenHistory( \"", file_name, "\", FILE_BIN | FILE_WRITE )", " - Error #", _GetLastError );
		return(-1);
	}

	//----   
	FileWriteInteger	( HistoryHandle, 400, LONG_VALUE );
	FileWriteString	( HistoryHandle, "Copyright  2009, komposter", 64 );
	FileWriteString	( HistoryHandle, StringConcatenate( "RB_", _Symbol ), 12 );
	FileWriteInteger	( HistoryHandle, PointsInBar, LONG_VALUE );
	FileWriteInteger	( HistoryHandle, Digits, LONG_VALUE );
	FileWriteInteger	( HistoryHandle, 0, LONG_VALUE );       //timesign
	FileWriteInteger	( HistoryHandle, 0, LONG_VALUE );       //last_sync
	FileWriteArray		( HistoryHandle, temp, 0, 13 );

	//+------------------------------------------------------------------+
	//|  
	//+------------------------------------------------------------------+
	datetime time; double bid; string tmp_str1, tmp_str2;
	now_time = 60; now_close = 0; now_open = 0; now_low = 0; now_high = 0; now_volume = 0;

	for ( int i = iBars( _Symbol, PERIOD_M1 )-1; i >= 0; i -- )
	{
		//     
		if ( (now_high-now_low)/Point >= PointsInBar || now_volume < 1 )
		{
			if ( (now_high-now_low)/Point >= PointsInBar )
			{
				FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
				FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
				FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
				FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
				FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
				FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
				FileFlush			( HistoryHandle );

				cnt_bars ++;
			}

			time			= iTime( _Symbol, PERIOD_M1, i ) / 60;
			time			*= 60;

			if ( time <= now_time ) time = now_time + 60;
			now_time		= time;

//			now_time		+= 60;	//   ,    2    

			now_open		= iOpen	( _Symbol, PERIOD_M1, i );
			now_low		= iLow	( _Symbol, PERIOD_M1, i );
			now_high		= iHigh	( _Symbol, PERIOD_M1, i );
			now_close	= iClose	( _Symbol, PERIOD_M1, i );
			now_volume	= iVolume( _Symbol, PERIOD_M1, i );
		}
		else
		{
			if ( iLow	( _Symbol, PERIOD_M1, i ) < now_low  ) now_low  = iLow	( _Symbol, PERIOD_M1, i );
			if ( iHigh	( _Symbol, PERIOD_M1, i ) > now_high ) now_high = iHigh	( _Symbol, PERIOD_M1, i );
			now_close = iClose( _Symbol, PERIOD_M1, i );
			now_volume += iVolume( _Symbol, PERIOD_M1, i );
		}
		cnt_ticks ++;
	}


	//    ,   0- 
	HistoryFilePos = FileTell( HistoryHandle);

	//  0-     
	FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
	FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
	FileFlush			( HistoryHandle );

	//  
	Print( "< - - -  : ", cnt_ticks, ",  : ", cnt_bars, " - - - >" );
	Print( "< - - -      \"RB_", _Symbol, PointsInBar, "\" - - - >" );
	
	//  
	RefreshWindow();

	return(0);
}

int start()
{
	if ( HistoryHandle < 0 ) return(-1);

	//+------------------------------------------------------------------+
	//|   
	//+------------------------------------------------------------------+
	//----  ""   
	FileSeek( HistoryHandle, HistoryFilePos, SEEK_SET );

	now_volume ++;

	//  
	if ( (now_high-now_low)/Point <= PointsInBar )
	{
		if ( Bid < now_low  ) now_low  = Bid;
		if ( Bid > now_high ) now_high = Bid;
		now_close = Bid;

		//  0-     
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
	}
	//    
	else
	{
		//  1- 
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume-1,DOUBLE_VALUE);
		FileFlush			( HistoryHandle );

		datetime time;
		time			= iTime( _Symbol, PERIOD_M1, 0 ) / 60;
		time			*= 60;

		if ( time <= now_time ) time = now_time + 60;
		now_time		= time;

//		now_time		= TimeCurrent();
//		now_time		+= 60;	//   ,    2    
		now_open		= Bid;
		now_low		= Bid;
		now_high		= Bid;
		now_close	= Bid;
		now_volume	= 1;

		//    ,   0- 
		HistoryFilePos = FileTell( HistoryHandle);

		//  0- 
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
	}

	//  
	RefreshWindow();
}

void RefreshWindow()
{
	//----  ,    ""  
	if ( hwnd == 0 )
	{
		hwnd = WindowHandle( StringConcatenate( "RB_", _Symbol ), PointsInBar );
		if ( hwnd != 0 ) { Print( "< - - -  ", "RB_", _Symbol, PointsInBar, " ! - - - >" ); }
	}
	//---- ,  ,  
	if ( hwnd != 0 ) { PostMessageA( hwnd, WM_COMMAND, 33324, 0 ); }
}

int deinit()
{
	if ( HistoryHandle > 0 )
	{
		//----  
		FileClose( HistoryHandle );
		HistoryHandle = -1;
	}
	return(0);
}

